import ProgressBarWrapper from './components/progressBarWrapper'

export default {
  progressBarWrapperComponentInstance: null,

  install(Vue, { name = '$progress' } = {}) {
    this.progressBarWrapperComponentInstance = this.createProgressBarWrapperComponent(Vue)

    const dispatcher = {
      start: options => this.progressBarWrapperComponentInstance.$emit('start', options),
      finish: options => this.progressBarWrapperComponentInstance.$emit('finish', options)
    }

    Object.assign(this, dispatcher)

    Vue[name] = Vue.prototype[name] = dispatcher
  },

  createProgressBarWrapperComponent(VueConsturctor) {
    let progressBarWrapperConstructor = VueConsturctor.extend(ProgressBarWrapper)
    const instance = new progressBarWrapperConstructor().$mount()

    document.body.appendChild(instance.$el)

    return instance
  }
}